# coding: utf-8

"""
Kaziro API

Kaziro Trading API Documentation

The version of the OpenAPI document: 1.0.6
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing_extensions import Self

from ..models.accepted_order import AcceptedOrder


class AcceptOrdersResponse(BaseModel):
    """
    AcceptOrdersResponse
    """  # noqa: E501

    success: StrictBool = Field(description="Indicates if the operation was successful.")
    message: StrictStr = Field(description="Descriptive message about the operation result.")
    accepted_orders: List[AcceptedOrder] = Field(description="List of accepted orders and their statuses.")
    __properties: ClassVar[List[str]] = ["success", "message", "accepted_orders"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AcceptOrdersResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in accepted_orders (list)
        _items = []
        if self.accepted_orders:
            for _item_accepted_orders in self.accepted_orders:
                if _item_accepted_orders:
                    _items.append(_item_accepted_orders.to_dict())
            _dict["accepted_orders"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AcceptOrdersResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "success": obj.get("success"),
                "message": obj.get("message"),
                "accepted_orders": [AcceptedOrder.from_dict(_item) for _item in obj["accepted_orders"]] if obj.get("accepted_orders") is not None else None,
            }
        )
        return _obj
