# coding: utf-8

"""
Kaziro API

Kaziro Trading API Documentation

The version of the OpenAPI document: 1.0.6
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, StrictStr
from typing_extensions import Self

from ..models.ohlc_data import OHLCData


class MarketOHLCData(BaseModel):
    """
    MarketOHLCData
    """  # noqa: E501

    market_id: StrictStr
    outcome_1_ohlc_data: List[OHLCData]
    outcome_2_ohlc_data: List[OHLCData]
    __properties: ClassVar[List[str]] = ["market_id", "outcome_1_ohlc_data", "outcome_2_ohlc_data"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MarketOHLCData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in outcome_1_ohlc_data (list)
        _items = []
        if self.outcome_1_ohlc_data:
            for _item_outcome_1_ohlc_data in self.outcome_1_ohlc_data:
                if _item_outcome_1_ohlc_data:
                    _items.append(_item_outcome_1_ohlc_data.to_dict())
            _dict["outcome_1_ohlc_data"] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in outcome_2_ohlc_data (list)
        _items = []
        if self.outcome_2_ohlc_data:
            for _item_outcome_2_ohlc_data in self.outcome_2_ohlc_data:
                if _item_outcome_2_ohlc_data:
                    _items.append(_item_outcome_2_ohlc_data.to_dict())
            _dict["outcome_2_ohlc_data"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MarketOHLCData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "market_id": obj.get("market_id"),
                "outcome_1_ohlc_data": [OHLCData.from_dict(_item) for _item in obj["outcome_1_ohlc_data"]] if obj.get("outcome_1_ohlc_data") is not None else None,
                "outcome_2_ohlc_data": [OHLCData.from_dict(_item) for _item in obj["outcome_2_ohlc_data"]] if obj.get("outcome_2_ohlc_data") is not None else None,
            }
        )
        return _obj
